// ----------------------------------------------------------------------------
//	M88 - PC-8801 series emulator
//	Copyright (C) cisc 1999.
//  x[Xɂ݂낪׍Ĥł
// ----------------------------------------------------------------------------
//	$Id: error.cpp,v 1.6 2002/04/07 05:40:08 cisc Exp $

#include "error.h"

Error::Errno Error::err = Error::NoError;

const char *Error::ErrorText[Error::EndofErrors] =
{
	// NoError
	"G[͂܂",
	// unknown
	"s̃G[܂",
	// MemAllocFailed
	"̊mۂɎs܂",
	// RomChange
	"w肳ꂽ@ROMC[WȂߋ@ύX܂\nݒmFĂ",
	// NoRom
	"ROMC[W܂\nݒƃt@CmFĂ",
	// RomSizeNG
	"ROMC[W̃TCYsł",
	// RomCrcNG
	"ROMC[WCRCsł",
	// SDLInitFailed
	"Cu(SDL)̏Ɏs܂",
	// InitFailed
	"Ɏs܂\nݒmFĂ",
	// FontFailed
	"tHg̓Ǎ݂Ɏs܂",
	// IniDefault
	"INIt@C̓Ǎ݂Ɏs܂\nftHgݒŋN܂",
	// IniReadFailed
	"INIt@C̓Ǎ݂Ɏs܂",
	// IniWriteFailed
	"INIt@C̕ۑɎs܂",
	// TapeMountFailed
	"TAPEC[W̃}EgɎs܂",
	// DiskMountFailed
	"DISKC[W̃}EgɎs܂",
	// ExtRomMountFailed
	"gROMC[W̃}EgɎs܂",
	// DokoReadFailed
	"ǂłLOADɎs܂",
	// DokoWriteFailed
	"ǂłSAVEɎs܂",
	// DokoDiffModel
	"ǂłLOADɎs܂\nۑƋ@킪قȂ܂",
};

const char *Error::GetErrorText()
{
	return ErrorText[err];
}

void Error::SetError( Errno e )
{
	err = e;
}

Error::Errno Error::GetError( void )
{
	return err;
}
