// ----------------------------------------------------------------------------
//	M88 - PC-8801 series emulator
//	Copyright (C) cisc 1999.
//  ١ˤߤٹΤǤ
// ----------------------------------------------------------------------------
//	$Id: error.h,v 1.2 1999/12/07 00:14:14 cisc Exp $

#ifndef common_error_h
#define common_error_h

class Error
{
public:
	enum Errno
	{
		NoError = 0,
		unknown,
		MemAllocFailed,
		RomChange,
		NoRom,
		RomSizeNG,
		RomCrcNG,
		SDLInitFailed,
		InitFailed,
		FontFailed,
		IniDefault,
		IniReadFailed,
		IniWriteFailed,
		TapeMountFailed,
		DiskMountFailed,
		ExtRomMountFailed,
		DokoReadFailed,
		DokoWriteFailed,
		DokoDiffModel,
		
		EndofErrors
	};

public:
	static void SetError( Errno e );
	static Errno GetError();
	static const char *GetErrorText();

private:
	Error();
	
	static Errno err;
	static const char *ErrorText[EndofErrors];
};

#endif // common_error_h
