#ifndef GLOBAL_H_INCLUDED
#define GLOBAL_H_INCLUDED

#include <string.h>

#include "pc6001v.h"
#include "ini.h"
#include "osd.h"


// ǥХå⡼	ꥦɥ or 쥸ɥ
// ǥХå⡼ɻϥե륹꡼󤪤ӥ饤ػ
// ե륹꡼⡼ɻϥơСػ
#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define	DISPMON		(cGlobal::GetMonDisp())
#define	DISPMEM		(cGlobal::GetMemDisp())
#define	DISPREG		(cGlobal::GetRegDisp())
#define	DISPDEBUG	(DISPMON || DISPMEM || DISPREG)
#define	DISPFULL	(!DISPDEBUG && cGlobal::GetFullScreen())
#define	DISPSCAN	(!DISPDEBUG && cGlobal::GetScanLine())
#define	DISPSTAT	(!DISPFULL && cGlobal::GetStatusBar())

#else

#define	DISPFULL	(cGlobal::Get()FullScreen)
#define	DISPSCAN	(cGlobal::GetScanLine())
#define	DISPSTAT	(cGlobal::GetStatusBar())

#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


#define	CMTCLOSE	0
#define	LOADOPEN	1
#define	SAVEOPEN	2


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cGlobal : public IDoko {
protected:
	// 
	static int P6Model;					//  60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR
	static BOOL WaitEnable;				// Waitͭե饰
	static char BasePath[PATH_MAX];		// ١ѥ
	static int OverClock;				// СåΨ (1-1000)%
	static char WCaption[256];			// ɥץ
	
	// INIեط
	static BOOL IsINI;					// INIեɹߥե饰
	static char IniPath[PATH_MAX];		// INIեѥ
	
	// ط
	static char RomPath[PATH_MAX];		// ROMѥ
	static BOOL UseExtRam;				// ĥRAMȤ TRUE: FALSE:ʤ
	static char ExtRomPath[PATH_MAX];	// ĥROMѥ
	static char ExtRomFile[PATH_MAX];	// ĥROMե̾
	static BOOL CheckCRC;				// CRCå TRUE:ͭ FALSE:̵
	
	// ܡɴط
	static int KeyRepeat;				// ԡ
	static int IndiKANA;				// ʥξ 0:OFF 1: 2:
	static int IndiCAPS;				// CAPSξ 0:abc 1:ABC
	
	// ɴط
	static int SampleRate;				// ץ󥰥졼
	static int SoundBuffer;				// ɥХåեĹ(ms)
	static int MasterVol;				// ޥ
	
	// PSGط
	static int PsgVol;					// PSG
	
	// ط
	static int VoiceVol;				// 
	
	// CMTط
	static char TapePath[PATH_MAX];		// TAPEѥ
	static char TapeFile[PATH_MAX];		// TAPEեեѥ
	static char TapeImgName[17];		// TAPE᡼̾
	static int CmtVol;					// TAPE˥
	static int Counter;					// TAPE 
	static int TapeSize;				// TAPE 
	static BOOL TurboTAPE;				// Turbo TAPEͭե饰
	static int CmtOpenStatus;			// CMT OPEN ơ
	static BOOL IsAutoStart;			// ȥȥե饰
	
	static char SaveFile[PATH_MAX];		// TAPE(SAVE)եեѥ
	
	// DISKط
	static char DiskPath[PATH_MAX];		// DISKѥ
	static char DiskFile[2][PATH_MAX];	// DISKեեѥ
	static char DiskImgName[2][17];		// DISK᡼̾
	static BOOL IsSystem[2];			// ƥǥե饰
	static BOOL IsProtect[2];			// ץƥȥե饰
	static int FddNum;					// FDD³
	
	// ̴ط
	static char ImgPath[PATH_MAX];		// ꡼󥷥åȳǼѥ
	static int Mode4Color;				// ⡼4顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ
	static BOOL ScanLine;				// 饤 TRUE: FALSE:ʤ
	static int ScanLineBr;				// 饤 (0-100)%
//	static BOOL N60Win;					// ɥ TRUE:N60 FALSE:N60m
	static BOOL FullScreen;				// ե륹꡼ TRUE:ե FALSE:ɥ
//	static BOOL CrtDisp;				// CRTɽ TRUE:ɽ FALSE:ɽ
	static BOOL StatDisp;				// ơСɽ TRUE:ɽ FALSE:ɽ
	static int FrameRate;				// ե졼졼
	
	// եȴط
	static char FontPath[PATH_MAX];		// ꡼󥷥åȳǼѥ
	static char FontFileZ[PATH_MAX];	// ѥեȥեѥ
	static char FontFileH[PATH_MAX];	// Ⱦѥեȥեѥ
	
	// ط
	static const SDL_Color STDColor[];	// ɸ५顼ǡ
	static SDL_Color UserColor[128];	// 桼ꥫ顼ǡ
	
	// ץ󥿴ط
	static char PrinterFile[PATH_MAX];	// ץ󥿥եեѥ
	
	// ɤǤSAVEط
	static char DokoFile[PATH_MAX];		// ɤǤSAVEեեѥ
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХåط
	static SDL_Surface *MonWin;			// ˥ɥ
	static SDL_Surface *MemWin;			// ꥦɥ
	static SDL_Surface *RegWin;			// 쥸ɥ
	static BOOL MonDisp;				// ˥ɥɽ TRUE:ɽ FALSE:ɽ
	static BOOL MemDisp;				// ꥦɥɽ TRUE:ɽ FALSE:ɽ
	static BOOL RegDisp;				// 쥸ɥɽ TRUE:ɽ FALSE:ɽ
	static BOOL TimerIntr;				// ޳ߵĥե饰
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	cGlobal();								// 󥹥ȥ饯
	virtual ~cGlobal();						// ǥȥ饯
	
	static BOOL Init();						// 
	static BOOL CreateINI();				// INIե뿷
	static void InitIni( cIni *, BOOL );	// INI֥Ƚ
	static void UnInit(){ IsINI = FALSE; }	// ˴
	
	// Хؿ
	static int  GetModel(){ return P6Model; }						// 
	static void SetModel( int data ){ P6Model = data; }				//     
	static int  GetMode4Color(){ return Mode4Color; }				// ⡼4顼⡼ɼ
	static void SetMode4Color( int data ){ Mode4Color = data; }		//                    
	static BOOL GetFullScreen(){ return FullScreen; }				// ե륹꡼⡼ɼ
	static void SetFullScreen( BOOL data ){ FullScreen = data; }	//                     
	static BOOL GetScanLine(){ return ScanLine; }					// 饤⡼ɼ
	static void SetScanLine( BOOL data ){ ScanLine = data; }		//                     
	static int  GetScanLineBr(){ return ScanLineBr; }				// 饤ټ
	static void SetScanLineBr( int data ){ ScanLineBr = data; }		//                   
	static BOOL GetWaitEnable(){ return WaitEnable; }				// Wait̵ͭ
	static void SetWaitEnable( BOOL data ){ WaitEnable = data; }	//             
	static BOOL GetTurboTAPE(){ return TurboTAPE; }					// Turbo TAPE̵ͭ
	static void SetTurboTAPE( BOOL data ){ TurboTAPE = data; }		//                   
	static BOOL GetStatusBar(){ return StatDisp; }					// ơСɽּ
	static void SetStatusBar( BOOL data ){ StatDisp = data; }		//                       
	
	static void SetCmtStatus( int data ){ CmtOpenStatus = data; }	// CMT OPEN ơ
	static void IncCmtCounter(){ Counter++; }						// TAPE 󥿤ʤ
	
	static char *GetBasePath(){ return BasePath; }					// ١ѥ
	static char *GetRomPath(){ return RomPath; }					// ROMѥ
	static char *GetTapePath(){ return TapePath; }					// TAPEѥ
	static void SetTapePath( char *data ){ strncpy( TapePath, data, MAX_PATH ); }	// 
	static char *GetDiskPath(){ return DiskPath; }					// DISKѥ
	static void SetDiskPath( char *data ){ strncpy( DiskPath, data, MAX_PATH ); }	// 
	static char *GetExtRomPath(){ return ExtRomPath; }				// ĥROMѥ
	static void SetExtRomPath( char *data ){ strncpy( ExtRomPath, data, MAX_PATH ); }	// 
	static char *GetImgPath(){ return ImgPath; }					// ꡼󥷥åȳǼѥ
	static char *GetInifileName(){ return IniPath; }				// INIե̾
	static char *GetTapeFile(){ return TapeFile; }					// TAPEե̾
	static void SetTapeFile( char *data ){ strncpy( TapeFile, data, MAX_PATH ); }	// 
	static char *GetSaveFile(){ return SaveFile; }					// TAPE(SAVE)ե̾
	static void SetSaveFile( char *data ){ strncpy( SaveFile, data, MAX_PATH ); }	// 
	static char *GetDiskFile( int drv ){ return DiskFile[drv]; }	// DISKե̾
	static void SetDiskFile( int drv, char *data ){ strncpy( DiskFile[drv], data, MAX_PATH ); }	// 
	static char *GetExtRomFile(){ return ExtRomFile; }				// ĥROMե̾
	static void SetExtRomFile( char *data ){ strncpy( ExtRomFile, data, MAX_PATH ); }	// 
	static char *GetFontPath(){ return FontPath; }					// FONTѥ
	static char *GetFontFileZ(){ return FontFileZ; }				// ѥեȥե̾
	static char *GetFontFileH(){ return FontFileH; }				// Ⱦѥեȥե̾
	static char *GetDokodemoName(){ return DokoFile; }				// ɤǤSAVEեեѥ
	
	static char *GetWCaption(){ return WCaption; }					// ɥץ
	
	static SDL_Color *GetColor( int n ){ return &UserColor[n]; }	// 
	
	static int GetFddNum(){ return FddNum; }						// FDD³
	static int GetSampleRate(){ return SampleRate; }				// ץ󥰥졼ȼ
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	static SDL_Surface *GetMonWin(){ return MonWin; }				// ˥ɥե
	static SDL_Surface *GetMemWin(){ return MemWin; }				// ꥦɥե
	static SDL_Surface *GetRegWin(){ return RegWin; }				// 쥸ɥե
	static BOOL GetMonDisp(){ return MonDisp; }						// ˥ɥɽּ
	static BOOL GetRegDisp(){ return RegDisp; }						// 쥸ɥɽּ
	static void SetRegDisp( BOOL data ){ RegDisp = data; }			//                           
	static BOOL GetMemDisp(){ return MemDisp; }						// ꥦɥɽּ
	static void SetMemDisp( BOOL data ){ MemDisp = data; }			//                        
	
	static BOOL GetTimerIntr(){ return TimerIntr; }					// ޳ߵĥե饰
	static void SetTimerIntr( BOOL data ){ TimerIntr = data; }		//                       
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


#endif	// GLOBAL_H_INCLUDED
