// OSˑ̔ėp[`(UIp)
// ɍ킹ĕR[hύX邱
//  Windows : ShiftJIS
//  Unix    : EUC

#include <windows.h>

#include "sdl/SDL_syswm.h"

#include "osd.h"
#include "p6v.h"

// CEBhENX̖O
#define	MWCLASS	"wmain"

static HANDLE hMutex;	// dN`FbNp̃~[ebNX

const char *cOsd::ColorName[] = {
					" MODE1 Set1 ", " MODE1 Set1 ", " MODE1 Set2 ", " MODE1 Set2 IW", 
					" MODE2 ", " MODE2 ", " MODE2 ", " MODE2 ", " MODE2 ", " MODE2 VA", " MODE2 }[^", " MODE2 IW",
					" MODE3 Set1 ", " MODE3 Set1 ", " MODE3 Set1 ", " MODE3 Set1 ",
					" MODE3 Set2 ", " MODE3 Set2 VA", " MODE3 Set2 }[^", " MODE3 Set2 IW", 
					" MODE4 Set1 ", " MODE4 Set1 ", " MODE4 Set2 ", " MODE4 Set2 ",
					" MODE4 Set1 ɂ "," MODE4 Set1 ɂ "," MODE4 Set1 ɂ -"," MODE4 Set1 ɂ -",
					" MODE4 Set2 ɂ "," MODE4 Set2 ɂ "," MODE4 Set2 ɂ "," MODE4 Set2 ɂ ",
					" mk2` ()", " mk2` ", " mk2` ", " mk2` ", " mk2` ", " mk2` Ԏ", " mk2` F", " mk2` DF", 
					" mk2` ", " mk2` ", " mk2` ", " mk2` ", " mk2` ", " mk2` }[^", " mk2` VA", " mk2` " };



////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
cOsd::cOsd()
{
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
cOsd::~cOsd()
{
}


////////////////////////////////////////////////////////////////
// dN`FbN
////////////////////////////////////////////////////////////////
BOOL cOsd::IsWorking( void )
{
	HANDLE hCheckMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, MWCLASS );
	if( hCheckMutex ){
		CloseHandle( hCheckMutex );
		return TRUE;
	}
	hMutex = CreateMutex( FALSE, 0, MWCLASS );
	return FALSE;
}


////////////////////////////////////////////////////////////////
// I
////////////////////////////////////////////////////////////////
void cOsd::Finish( void )
{
	// Mutex J
	ReleaseMutex( hMutex );
}


////////////////////////////////////////////////////////////////
// W[pX擾
////////////////////////////////////////////////////////////////
int cOsd::GetModulePath( char *path )
{
	char Drive[3];
	char Dir[PATH_MAX];
	
	int num = GetModuleFileName( NULL, path, PATH_MAX );
	_splitpath( path, Drive, Dir, NULL, NULL );
	sprintf( path, "%s%s", Drive, Dir );
	if( num ) DELIMITER( path );
	ADDDELIMITER( path );	// Ô
	
	return strlen( path );
}


////////////////////////////////////////////////////////////////
// tpXt@C擾
////////////////////////////////////////////////////////////////
char *cOsd::GetFileNamePart( char *path )
{
	char Drive[3];
	char Dir[PATH_MAX];
	
	_splitpath( path, Drive, Dir, NULL, NULL );
	
	return &path[strlen( Drive ) + strlen( Dir )];
}


////////////////////////////////////////////////////////////////
// t@C̑݃`FbN
////////////////////////////////////////////////////////////////
BOOL cOsd::FileExist( char *fullpath )
{
	PRINTD( OSD_LOG, "[OSD][FileExist]\n" );
	
	char filename[PATH_MAX+1];
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	BOOL ret = FALSE;
	
	strncpy( filename, fullpath, PATH_MAX );
	
	DELDELIMITER( filename );
	UNDELIMITER( filename );
	
	hFind = FindFirstFile( filename, &FindFileData );
	if( hFind != INVALID_HANDLE_VALUE ) ret = TRUE;
	FindClose( hFind );
	
	return ret;
}


///////////////////////////////////////////////////////////
// t@C̎Q
///////////////////////////////////////////////////////////
char *cOsd::FileDiaog( void *hwnd, FileMode mode, char *title, char *filter, char *fullpath, char *path, char *ext )
{
	OPENFILENAME fname;
	char File[PATH_MAX] = "";
	char Path[PATH_MAX] = "";
	BOOL ret = FALSE;
	
	if( !fullpath ) return NULL;
	
	if( FileExist( fullpath ) ){
		strncpy( File, fullpath, PATH_MAX );
		UNDELIMITER( File );
	}else if( path ){
		strncpy( Path, path,     PATH_MAX );
		UNDELIMITER( Path );
	}
	
	ZeroMemory( &fname, sizeof(OPENFILENAME) );
	
	fname.lStructSize     = sizeof(OPENFILENAME);
	fname.hwndOwner       = (HWND)hwnd;		// ẽEBhEnh
	fname.lpstrFilter     = filter;			// t@CtB^
	fname.nFilterIndex    = 1;				// 1Ԗڂ̃t@CtB^g
	fname.lpstrFile       = File;			// IꂽtpX̊i[
	fname.nMaxFile        = sizeof(File);	// ̃TCY
	fname.lpstrInitialDir = Path;			// tH_
	fname.lpstrTitle      = title;			// ^Cg
	fname.lpstrDefExt     = ext;			// gqȗĂꍇɒǉgq
//	fname.Flags           = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
	
	if( mode == FileSave ){
		fname.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetSaveFileName( &fname );
	}else{
		fname.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
		ret = GetOpenFileName( &fname );
	}
	
//	if( GetOpenFileName( &fname ) ){
	if( ret ){
		DELIMITER( File )
		// pXۑ
		if( path ) strncpy( path, File, fname.nFileOffset );
		// tpXۑ
		if( fullpath ) strncpy( fullpath, File, PATH_MAX );
		// t@Cւ̃|C^Ԃ
		return fullpath + fname.nFileOffset;
	}else
		return NULL;
}


////////////////////////////////////////////////////////////////
// et@CI
////////////////////////////////////////////////////////////////
char *cOsd::FileSelect( void *hwnd, FileDlg type, char *fullpath, char *path )
{
	HWND shwnd    = (HWND)hwnd;
	FileMode mode = FileLoad;
	char *title   = NULL;
	char *filter  = NULL;
	char *ext     = NULL;
	
	switch( type ){
	case TapeLoad:	// TAPE(LOAD)I
		mode   = FileLoad;
		title  = "TAPE(LOAD)J";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case TapeSave:	// TAPE(SAVE)I
		mode   = FileSave;
		title  = "TAPE(SAVE)J";
		filter = "TAPEC[W\0*.p6t;*.cas;*.p6\0"
    			 "P6T` (*.p6t)\0*.p6t\0"
    			 "x^` (*.cas;*.p6)\0*.cas\0"
    			 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "p6t";
		break;
		
	case Disk:		// DISKI
		mode   = FileLoad;
		title  = "DISKJ";
		filter = "DISKC[W\0*.d88\0"
				 "D88` (*.d88)\0*.d88\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "d88";
		break;
		
	case ExtRom:	// gROMI
		mode   = FileLoad;
		title  = "gROMC[WI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
		
	case Printer:	// v^[o̓t@CI
		mode   = FileSave;
		title  = "v^[o̓t@CI";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		ext    = "txt";
		break;
		
	case FontZ:		// SptHgt@CI
		mode   = FileLoad;
		title  = "SptHgt@CI";
		filter = "BDFtHg (*.bdf)\0*.bdf\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "bdf";
		break;
		
	case FontH:		// ptHgt@CI
		mode   = FileLoad;
		title  = "ptHgt@CI";
		filter = "BDFtHg (*.bdf)\0*.bdf\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "bdf";
		break;
		
	case DokoLoad:	// ǂłLOADt@CI
		mode   = FileLoad;
		title  = "ǂłLOADt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	case DokoSave:	// ǂłSAVEt@CI
		mode   = FileSave;
		title  = "ǂłSAVEt@CI";
		filter = "ǂłSAVE` (*.dds)\0*.dds\0"
				 "SẴt@C (*.*)\0*.*\0\0";
		ext    = "dds";
		break;
		
	default:		// ėp
		mode   = FileLoad;
		title  = "t@CJ";
		filter = "SẴt@C (*.*)\0*.*\0\0";
		break;
	}
	
	// EBhEnh NULL ,XN[T[tFX̃nh擾݂
	if( !hwnd ){
		SDL_SysWMinfo WinInfo;
		SDL_VERSION( &WinInfo.version );
		shwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	}
	
	return FileDiaog( shwnd, mode, title, filter, fullpath, path, ext );
}


////////////////////////////////////////////////////////////////
// bZ[W\
////////////////////////////////////////////////////////////////
int cOsd::Message( char *mes, char *cap, int type )
{
	int Type = MB_OK;
	
	// bZ[W{bNX̃^Cv
	switch( type&0x000f ){
	case OSDM_OK:			Type = MB_OK;			break;
	case OSDM_OKCANCEL:		Type = MB_OKCANCEL;		break;
	case OSDM_YESNO:		Type = MB_YESNO;		break;
	case OSDM_YESNOCANCEL:	Type = MB_YESNOCANCEL;	break;
	}
	
	// bZ[W{bNX̃ACR^Cv
	switch( type&0x00f0 ){
	case OSDM_ICONERROR:	Type |= MB_ICONERROR;		break;
	case OSDM_ICONQUESTION:	Type |= MB_ICONQUESTION;	break;
	case OSDM_ICONWARNING:	Type |= MB_ICONWARNING;		break;
	case OSDM_ICONINFO:		Type |= MB_ICONINFORMATION;	break;
	}
	
	// eEBhE̓XN[T[tFXƌߑł
	SDL_SysWMinfo WinInfo;
	SDL_VERSION( &WinInfo.version );
	HWND hwnd = SDL_GetWMInfo( &WinInfo ) ? WinInfo.window : NULL;
	
	int res = MessageBox( hwnd, mes, cap, Type | MB_TOPMOST );
	
	switch( res ){
	case IDOK:	return OSDR_OK;
	case IDYES:	return OSDR_YES;
	case IDNO:	return OSDR_NO;
	default:	return OSDR_CANCEL;
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////



/*
////////////////////////////////////////////////////////////////
// EUC -> SJIS(1)
////////////////////////////////////////////////////////////////
void euc2sjis( BYTE *kj1, BYTE *kj2 )
{
	// zgEUC?
	if( (*kj1 >= 0xa1 && *kj1 <= 0xfe) && (*kj2 >= 0xa1 && *kj1 <= 0xfe) ){
		if( *kj1 & 0x01 ){
			*kj1 >>= 1;
			if( *kj1 < 0x6F ) *kj1 += 0x31;
			else              *kj1 += 0x71;
			if( *kj2 > 0xDF ) *kj2 -= 0x60;
			else              *kj2 -= 0x61;
		}else{
			*kj1 >>= 1;
			if( *kj1 < 0x6F ) *kj1 += 0x30;
			else              *kj1 += 0x70;
			*kj2 -= 0x02;
		}
	}
}

////////////////////////////////////////////////////////////////
// EUC -> SJIS()
////////////////////////////////////////////////////////////////
void str_euc2sjis( char *fi, char *fo )
{
	BYTE *str = (BYTE *)fi;
	BYTE *sto = (BYTE *)fo;
	BYTE c1, c2 = 0;
	
	while( (c1 = *(str++)) != '\0' ){
		if( c1 < 0x80 )	*(sto++) = c1;
		else{
			if( (c2 = *(str++)) == '\0' ) break;
			if( c1 == 0x8E ) *(sto++) = c2;
			else{
				euc2sjis( &c1, &c2 );
				*(sto++) = c1;
				*(sto++) = c2;
			}
		}
	}
}
*/
