#include <stdio.h>
#include <shlobj.h>

#include "tape.h"


// P6TեޥåVer.2
//  Ūˤϡ֥٥᡼+եå+٥᡼(4byte)פȤ¤
//  եåˤDATA֥å󤬴ޤޤ롣
//  DATA֥å̵ڤȤ1ȿ롣
//  BASICʤɡ֥إåܥǡפȤ¤ξ硤DATA֥å2ĤȤʤ뤬
//  IDֹƱˤ뤳ȤǴϢդƴǤ롣
//
// [եå]
//  header (2byte) : "P6"
//  ver    (1byte) : С
//  dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
//  start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
//  basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
//  page   (1byte) : ڡ
//  askey  (2byte) : ȥȥޥʸ
//  ...ޥɤϤθaskeyʬ³
//  exhead (2byte) : ĥ󥵥(64KBޤ)
//  ...ĥ󤬤Ϥθexheadʬ³
//
// [DATA֥å]
//  header (2byte) : "TI"
//  id     (1byte) : IDֹ(DATA֥åϢդ)
//  name  (16byte) : ǡ̾(15ʸ+'00H')
//  baud   (2byte) : ܡ졼(600/1200)
//  stime  (2byte) : ̵λ(ms)
//  ptime  (2byte) : ԡλ(ms)
//  offset (4byte) : ٥᡼ƬΥեå
//  size   (4byte) : ǡ


// ȿ
#define PG_HI	(0)
#define PG_LO	(1)

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6tape::cP6tape( void )
{
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6tape::~cP6tape( void )
{
	Unmount();
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6tape::Init( cRing *buf )
{
	// P6T ΰ(ꥻåȻˤ̵)
	p6t = NULL;
	
	// ȥ꡼ݥ
	Buf = buf;
	
	// TAPE˥
	Volume = DEFAULT_TAPEVOL;
	
	// ȥ̵
	AutoStartExec = FALSE;
	ZeroMemory( &ak, sizeof( AKEY ) );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void cP6tape::Reset( void )
{
	if( !p6t ) return;
	
	// ȥͭ?
	if( p6t->GetStart() ){
		// TAPEꥻå
		p6t->Reset();
		
		// Хåե˽
		// PC-6001
		if( cGlobal::GetModel() == 60 )
			// ĥBASIC+FDDϤȤꤢ̵
			sprintf( ak.Buffer, "%c%c", p6t->GetPage()+'0', 0x0d );
		// PC-6001mk2 ʹ
		else{
			switch( p6t->GetBASIC() ){
			case 1:
			case 2:
				sprintf( ak.Buffer, "%c%c%c", p6t->GetBASIC()+'0', p6t->GetPage()+'0', 0x0d );
				break;
				
			case 3:
			case 4:
			case 5:
				if( !cGlobal::GetFddNum() )	// ??? ºݤ?
					sprintf( ak.Buffer, "%c%c%c",   p6t->GetBASIC()+'0',       p6t->GetPage()+'0', 0x0d );
				else
					sprintf( ak.Buffer, "%c%c%c%c", p6t->GetBASIC()+'0', 0x0d, p6t->GetPage()+'0', 0x0d );
			}
		}
		memcpy( &ak.Buffer[strlen(ak.Buffer)], p6t->GetAutoStartStr(), p6t->GetAutoStartLen() );
		ak.Num    = strlen(ak.Buffer);		// Ĥʸ
		ak.Wait   = 200*DEFAULT_CMT_HZ/100;	// Ԥ(2sec)
		ak.Relay  = FALSE;					// 졼åOFFԤե饰
		ak.Seek   = 0;
	}
}


////////////////////////////////////////////////////////////////
// ȥ1ʸ
////////////////////////////////////////////////////////////////
BYTE cP6tape::GetAutoKey( BOOL relay )
{
	// 졼OFFԤ
	if( ak.Relay ){
		if( relay ) return 0;
		else		ak.Relay = FALSE;
	}
	
	// Ԥ?
	if( --ak.Wait ) return 0;
	
	// ʸ
	if( ak.Num-- ){
		BYTE dat = ak.Buffer[ak.Seek++];
		switch( dat ){
		case 0x0a:	// '\r' 졼OFFԤ
			ak.Relay = TRUE;
			dat = 0x0d;
		case 0x0d:	// '\n' ?
			ak.Wait = 150*DEFAULT_CMT_HZ/100;	// Ԥ1.5sec
			break;
		default:	// ̤ʸ
			ak.Wait = 2*DEFAULT_CMT_HZ/100;		// Ԥ20msec
		}
		return dat;
	}else
		AutoStartExec = FALSE;
	
	return 0;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
BOOL cP6tape::Mount( char *filename )
{
	PRINTD1( TAPE_LOG, "[TAPE][Mount] %s\n", filename  );
	
	// ⤷ޥȺѤߤǤХޥȤ
	if( p6t ) Unmount();
	
	// P6T
	p6t = new cP6T;
	
	// ե뤫ɹ
	if( !p6t->Readf( filename ) ){
		delete p6t;
		p6t = NULL;
		return FALSE;
	}
	
	// ե̾¸
	strncpy( FilePath, filename, MAX_PATH );
	
	// ȥ?
	AutoStartExec = p6t->GetStart();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
void cP6tape::Unmount( void )
{
	PRINTD( TAPE_LOG, "[TAPE][Unmount]\n" );
	
	if( p6t ){
		delete p6t;
		p6t = NULL;
		*FilePath = '\0';
	}
}


////////////////////////////////////////////////////////////////
// CMT 1ʸɹ
// ̤͡ϥǡ(ԡ,̵,ǡ) ̤ϥǡ
// 졼ON & CMT OPEN 
////////////////////////////////////////////////////////////////
WORD cP6tape::CmtRead( void )
{
	PRINTD( TAPE_LOG, "[TAPE][CmtRead] " );
	
	// TAPE᡼ץ Ǥʤ̵
	if( !p6t ) return PG_S;
	
	// ̵Ԥ
	if( p6t->IsSWaiting() ){
//		PRINTD1( TAPE_LOG, "swait:%d\n", p6t->swait );
		PRINTD( TAPE_LOG, "swait\n" );
		return PG_S;
	}
	
	// ԡԤ
	if( p6t->IsPWaiting() ){
//		PRINTD1( TAPE_LOG, "pwait:%d\n", p6t->pwait );
		PRINTD( TAPE_LOG, "pwait\n" );
		return PG_P;
	}
	
	// ǡɹ
	PRINTD( TAPE_LOG, "read\n" );
	return PG_D | p6t->ReadOne();
}


////////////////////////////////////////////////////////////////
// ٥᡼
////////////////////////////////////////////////////////////////
DWORD cP6tape::GetSize( void )
{
	if( p6t ) return p6t->GetSize();
	else      return 0;
}


////////////////////////////////////////////////////////////////
// TAPE̾
////////////////////////////////////////////////////////////////
char *cP6tape::GetTapeName( void )
{
	if( p6t ) return p6t->GetPart(0)->GetName();
	else      return NULL;
}


/*
////////////////////////////////////////////////////////////////
// CMT 1ʸ
// 졼ON & CMT OPEN 
////////////////////////////////////////////////////////////////
void cmt_save( byte data )
{
	if( !fsv->fp ){
		set_intr_cmtE();	// TAPEץ󤵤ƤʤХ顼ΩƤ
		return;
	}
	
	fputc( data, fsv->fp );
}
*/


////////////////////////////////////////////////////////////////
// TAPE˥
////////////////////////////////////////////////////////////////
void cP6tape::SetVolume( int vol )
{
	Volume = min( max( vol, 0 ), 100 );
}


////////////////////////////////////////////////////////////////
// ȥ꡼๹
// 졼ON & CMT OPEN 
////////////////////////////////////////////////////////////////
WORD cP6tape::Update( void )
{
	PRINTD( TAPE_LOG, "[TAPE][Update]\n" );
	
	// 100ms()ʬΥǡ
	int length = cGlobal::GetSampleRate() / DEFAULT_CMT_HZ;
	WORD rd = PG_S;
	
	// TAPE᡼ץ?
	if( p6t ){
		int bdata;
		
		rd = CmtRead();		// CMT 1ʸɹ
		
		switch( rd & 0xff00 ){	// ǡϡ
		case PG_P:	// ԡξ
			// ⲻ˥å
			while( length-- ) Buf->Write( GetSinCurve( PG_HI ) );
			
			break;
		case PG_S:	// ̵ξ
			while( length-- ) Buf->Write( 0 );
			
			break;
		case PG_D:	// ǡξ
			cGlobal::IncCmtCounter();	// TAPE 󥿤ʤ
			
			// ȥӥå 1bit
			// ǡӥå   8bits
			// ȥåץӥå 3bits
			
			bdata = length/12;	// 1bitΥǡ
			// ȥӥå
			for( int i=0; i<bdata; i++ ){
				Buf->Write( GetSinCurve( PG_LO ) );
			}
			// ǡӥå
			for( int j=7; j>=0; j-- ){
				int hilo = (rd>>j)&1 ? PG_HI : PG_LO;
				for( int i=0; i<bdata; i++ ){
					Buf->Write( GetSinCurve( hilo ) );
				}
			}
			// ȥåץӥå
			for( length -= bdata*9; length > 0; length-- ){
				Buf->Write( GetSinCurve( PG_HI ) );
			}
			break;
		}
	}
	
	return rd;
}


////////////////////////////////////////////////////////////////
// sinȼ
////////////////////////////////////////////////////////////////
Sint16 cP6tape::GetSinCurve( int fq )
{
	const Sint16 sinc[] = {
		     0,   2856,   5690,   8481,  11207,  13848,  16384,  18794,  21062,
		 23170,  25101,  26841,  28377,  29697,  30791,  31650,  32269,  32642,
		 32767,  32642,  32269,  31650,  30791,  29697,  28377,  26841,  25101,
		 23170,  21062,  18794,  16384,  13848,  11207,   8481,   5690,   2856,
		     0,  -2856,  -5690,  -8481, -11207, -13848, -16384, -18794, -21062,
		-23170, -25101, -26841, -28377, -29697, -30791, -31650, -32269, -32642,
		-32767, -32642, -32269, -31650, -30791, -29697, -28377, -26841, -25101,
		-23170, -21062, -18794, -16384, -13848, -11207,  -8481,  -5690,  -2856
	};
	static int n=0;
	
	// ץ󥰥졼ȤȼȿǴְδֳ֤
	// ǡơ֥44100Hz,600ܡο
	// Ȥꤢ1200ܡʤΤ2
	n += (fq == PG_HI ? 2:1 ) * DEFAULT_SAMPLE_RATE / cGlobal::GetSampleRate() * 2;
	
	// ơ֥륵72(sizeof(sinc[]))
	if( n >= 72 ) n -= 72;
	
	Sint16 ret = ( sinc[n] * Volume ) / 100;
	
	// ⲻ㲻ǲ̥٥뤬㤦餷
	if( fq == PG_HI ) ret = (Sint16)((double)ret/(double)1.32);
	
	return ret;
}




////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6csave::cP6csave( void )
{
	fp   = NULL;
	Baud = 1200;
	
	*FilePath = '\0';
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6csave::~cP6csave( void )
{
	Unmount();
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6csave::Init( char *filename )
{
	// ե̾¸
	strncpy( FilePath, filename, PATH_MAX );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
BOOL cP6csave::Mount( char *filename )
{
	if( fp ) fclose( fp );
	
	fp = fopen( filename, "wb" );
	
	if( fp ){
		// ե̾¸
		strncpy( FilePath, filename, PATH_MAX );
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
void cP6csave::Unmount( void )
{
	if( fp ){
		// եåդ(Ȥꤢ٥)
		fflush( fp );
		int beta = ftell( fp );	// ٥᡼
		
		// [եå]
		fputc( 'P', fp );	// header (2byte) : "P6"
		fputc( '6', fp );
		fputc( 2, fp );		// ver    (1byte) : С
		fputc( 1, fp );		// dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
		fputc( 0, fp );		// start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
		fputc( 1, fp );		// basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
		fputc( 1, fp );		// page   (1byte) : ڡ
		fputc( 0, fp );		// askey  (2byte) : ȥȥޥʸ
		fputc( 0, fp );		// ...ޥɤϤθaskeyʬ³
		fputc( 0, fp );		// exhead (2byte) : ĥ󥵥(64KBޤ)
		fputc( 0, fp );		// ...ĥ󤬤Ϥθexheadʬ³
		
		// [DATA֥å]
		fputc( 'T', fp );				// header (2byte) : "TI"
		fputc( 'I', fp );
		fputc( 0, fp );					// id     (1byte) : IDֹ(DATA֥åϢդ)
		for( int i=0; i<16; i++ ) fputc( 0, fp );	// name  (16byte) : ǡ̾(15ʸ+'00H')
		fputc( (Baud   )&0xff, fp );	// baud   (2byte) : ܡ졼(600/1200)
		fputc( (Baud>>8)&0xff, fp );
		fputc( 0x48, fp );				// stime  (2byte) : ̵λ(ms)
		fputc( 0x0d, fp );
		fputc( 0x48, fp );				// ptime  (2byte) : ԡλ(ms)
		fputc( 0x0d, fp );
		fputc( 0, fp );					// offset (4byte) : ٥᡼ƬΥեå
		fputc( 0, fp );
		fputc( 0, fp );
		fputc( 0, fp );
		fputc( (beta    )&0xfd, fp );	// size   (4byte) : ǡ
		fputc( (beta>> 8)&0xfd, fp );
		fputc( (beta>>16)&0xfd, fp );
		fputc( (beta>>24)&0xfd, fp );
		
		// [٥᡼]
		fputc( (beta    )&0xfd, fp );
		fputc( (beta>> 8)&0xfd, fp );
		fputc( (beta>>16)&0xfd, fp );
		fputc( (beta>>24)&0xfd, fp );
		
		fclose( fp );
		fp = NULL;
	}
}


////////////////////////////////////////////////////////////////
// CMT 1ʸ
////////////////////////////////////////////////////////////////
void cP6csave::CmtWrite( BYTE data )
{
	// ե뤬Ƥʤг
	if( !fp ){
		fp = fopen( FilePath, "wb" );
		if( !fp ) return;
	}
	
	fputc( data, fp );
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6tape::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	// TAPEޥȤƤʤв⤷ʤ
	if( !GetTapeName() ) return TRUE;
	
	Ini->PutEntry( "TAPE", NULL, "FilePath",		"%s",	FilePath );
	
	Ini->PutEntry( "TAPE", NULL, "AutoStartExec",	"%s",	AutoStartExec ? "Yes" : "No" );
	if( AutoStartExec && ak.Num ){
		char strva[NumOfAKEY+1];
		for( int i=0; i<ak.Num; i++ ) sprintf( &strva[i*2], "%02X", ak.Buffer[i] );
		Ini->PutEntry( "TAPE", NULL, "AKEY_Buffer",		"%s",	strva );
		Ini->PutEntry( "TAPE", NULL, "AKEY_Wait",		"%d",	ak.Wait );
		Ini->PutEntry( "TAPE", NULL, "AKEY_Relay",		"%s",	ak.Relay ? "Yes" : "No" );
		Ini->PutEntry( "TAPE", NULL, "AKEY_Seek",		"%d",	ak.Seek );
	}
	
	return p6t->DokoSave( Ini );
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6tape::DokoLoad( cIni *Ini )
{
	char strva[MAX_PATH];
	
	if( !Ini ) return FALSE;
	
	if( Ini->GetString( "TAPE", "FilePath", strva, "" ) ){
		if( !Mount( strva ) ) return FALSE;
		if( !p6t->DokoLoad( Ini ) ) return FALSE;
	}else
		Unmount();
	
	Ini->GetTruth(  "TAPE",	"AutoStartExec",	&AutoStartExec,	AutoStartExec );
	if( Ini->GetString( "TAPE", "AKEY_Buffer", strva, "" ) ){
		ak.Num = strlen( strva ) / 2;
		for( int i=0; i<ak.Num; i++ ){
			char dt[5] = "0x";
			strncpy( &dt[2], &strva[i*2], 2 );
			ak.Buffer[i] = strtol( dt, NULL, 16 );
		}
		Ini->GetInt(   "TAPE",	"AKEY_Wait",		&ak.Wait,		ak.Wait );
		Ini->GetTruth( "TAPE",	"AKEY_Relay",		&ak.Relay,		ak.Relay );
		Ini->GetInt(   "TAPE",	"AKEY_Seek",		&ak.Seek,		ak.Seek );
	}
	
	return TRUE;
}
