#ifndef BREAKPOINTL_H_INCLUDED
#define BREAKPOINTL_H_INCLUDED

#include "pc6001v.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
// ֥졼ݥȤο
#define	NR_BP	(10)

class cBreakPoint {
public:
	enum BPtype{ BP_NONE, BP_PC, BP_READ, BP_WRITE, BP_IN, BP_OUT, EndofBPtype };
	
private:
	typedef struct{
		BPtype Type;
		WORD Addr;
	} BreakPoint;
	
	BreakPoint BP[NR_BP];	// ֥졼ݥ
	
	// ֥졼ݥȤξ
	int BPNo;
	WORD BPAddr;
	BYTE BPData;
	char *BPStr;
	
	// ֥졼׵
	BOOL ReqBreak;
	
public:
	cBreakPoint();
	~cBreakPoint();
	
	BOOL ExistBreakPoint();											// ֥졼ݥȤ̵ͭå
	BOOL CheckBreakPoint( BPtype, WORD, BYTE, char * );				// ֥졼ݥȤå
	
	void ClearStatus();												// ֥졼ݥȤξ򥯥ꥢ
	
	BPtype GetType( int num ){ return BP[num].Type; }				// ֥졼ݥȤΥפ
	WORD GetAddr( int num ){ return BP[num].Addr; }					// ֥졼ݥȤΥɥ쥹
	void SetType( int num, BPtype type ){ BP[num].Type = type; }	// ֥졼ݥȤΥפ
	void SetAddr( int num, WORD addr ){ BP[num].Addr = addr; }		// ֥졼ݥȤΥɥ쥹
	
	BOOL IsReqBreak(){ return ReqBreak; }
	void SetBreak()  { ReqBreak = TRUE; }
	void ResetBreak(){ ReqBreak = FALSE; }
	
};


extern cBreakPoint BP;


#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

#endif	// BREAKPOINTL_H_INCLUDED
