#include "intr.h"


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cP6intr::cP6intr()
{
	PRINTD( CONST_LOG, "cP6intr\n" );
}

cP6intr60::cP6intr60( const ID& id ) : Device(id)
{
	PRINTD( CONST_LOG, "cP6intr60\n" );
}

cP6intr62::cP6intr62( const ID& id ) : Device(id)
{
	PRINTD( CONST_LOG, "cP6intr62\n" );
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cP6intr::~cP6intr()
{
	PRINTD( CONST_LOG, "~cP6intr\n" );
}

cP6intr60::~cP6intr60()
{
	PRINTD( CONST_LOG, "~cP6intr60\n" );
}

cP6intr62::~cP6intr62()
{
	PRINTD( CONST_LOG, "~cP6intr62\n" );
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL cP6intr::Init( void )
{
	PRINTD( INTR_LOG, "[INTR][Init]\n" );
	
	Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void cP6intr60::Reset( void )
{
	PRINTD( INTR_LOG, "[INTR][Reset]\n" );
	
	// ߥɥ쥹
	TimerAddr = 3;
	
	// Ƽѿ
	TimerIntrEnable  =			// ޳ߵĥե饰ߤ
	IntrReserved     = FALSE;	// ͽե饰ߤ
	
	// Ƽȯե饰ߤ
	IntrKEY1 =
	IntrKEY2 =
	IntrKEY3 =
	IntrTIMER =
	IntrCMT_R =
	IntrCMT_E =
	IntrJOY = FALSE;
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	TimerCount = 		// 1ô֤Υ޳߲
	CmtCount   = 0;		// 1ô֤CMT߲
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}

void cP6intr62::Reset( void )
{
	PRINTD( INTR_LOG, "[INTR][Reset]\n" );
	
	// ߥɥ쥹
	TimerAddr = 3;
	Int1Addr  = Int2Addr = 0;
	
	// Ƽѿ
	TimerIntrEnable  =			// ޳ߵĥե饰ߤ
	TimerIntrEnable2 =			// ޳ߵĥե饰ߤ(mk2ʹ)
	IntrReserved     = FALSE;	// ͽե饰ߤ
	
	// Ƽȯե饰ߤ
	IntrKEY1 =
	IntrKEY2 =
	IntrKEY3 =
	IntrTIMER =
	IntrCMT_R =
	IntrCMT_E =
	IntrJOY = FALSE;
	
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	TimerCount = 		// 1ô֤Υ޳߲
	CmtCount   = 0;		// 1ô֤CMT߲
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}


////////////////////////////////////////////////////////////////
// ߥå
// ȯꤷPoretAΥǡ򥻥å
// ߤ̤ͥϤ褯狼
////////////////////////////////////////////////////////////////
int cP6intr::IntrCheck( void )
{
	int	IntrNo = -1;
	
	// ޳
	if( IntrTIMER && IsTimerIntrEnable() ){
		IntrTIMER = FALSE;
		IntrNo = TimerAddr;
		#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
		TimerCount++;
		#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	}
	// 1 1
	else if( IntrKEY1 ){
		IntrKEY1 = FALSE;
		IntrNo = 7;
	}
	// 1 2
	// 1ȤΤ???
//	else if( IntrKEY1 ){
//		IntrKEY1 = FALSE;
//		IntrNo = 8;
//	}
	// CMT READ 
	else if( IntrCMT_R ){
		IntrCMT_R = FALSE;
		IntrNo = 4;
		SetIntrReserved( ResCmt );
	}
	// CMT ERROR 
	else if( IntrCMT_E ){
		IntrCMT_E = FALSE;
		IntrNo = 9;
	}
	// 2
	else if( IntrKEY2 ){
		IntrKEY2 = FALSE;
		IntrNo = 10;
	}
	// 3
	else if( IntrKEY3 ){
		IntrKEY3 = FALSE;
		IntrNo = 1;
	}
	// RS232S  (̤)
//	else if( FALSE ){
//		IntrNo = 0;
//	}
	// ѥ
	else if( IntrJOY ){
		IntrJOY = FALSE;
		IntrNo = 11;
	}
	
	if( IntrNo >= 0 ){
		PRINTD1( INTR_LOG, "[INTR][IntrCheck] IntrNo = %d\n", IntrNo  );
		IntrNo <<= 1;
	}
	
	return IntrNo;
}


////////////////////////////////////////////////////////////////
// ޳ȯ
// :׵
////////////////////////////////////////////////////////////////
void cP6intr::SetTimerIntr( BOOL timerreq )
{
	PRINTD( INTR_LOG, "[INTR][SetTimerIntr]" );
	
	if( timerreq ){
		IntrTIMER = TRUE;
		
		PRINTD( INTR_LOG, " -> OnTimerIntr" );
	}
	
	PRINTD( INTR_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// CMTȯ
////////////////////////////////////////////////////////////////
void cP6intr::SetCmtIntr( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][SetCmtIntr]" );
	
	IntrCMT_R = TRUE;
	ResCmt = data;
	#if USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	CmtCount++;
	#endif			// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
}


////////////////////////////////////////////////////////////////
// ȯ
////////////////////////////////////////////////////////////////
void cP6intr::SetKeyIntr( int type, BYTE data )
{
	PRINTD1( INTR_LOG, "[INTR][SetKeyIntr] Type:%d\n", type );
	
	// ߵ/ػߤˤ餺PortAˤϥǡ餷
	// 8049 & 8255 λŻ?
	if( SetIntrReserved( data ) ){
		switch( type ){
		case 1: IntrKEY1 = TRUE; break;	// 1ȯ
		case 2: IntrKEY2 = TRUE; break;	// 2ȯ
		case 3: IntrKEY3 = TRUE; break;	// 3ȯ
		}
	}
}


////////////////////////////////////////////////////////////////
// ѥȯ
////////////////////////////////////////////////////////////////
void cP6intr::SetJoyIntr( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][SetJoyIntr]\n" );
	
	// ߵ/ػߤˤ餺PortAˤϥǡ餷
	// 8049 & 8255 λŻ?
	if( SetIntrReserved( data ) ) IntrJOY = TRUE;
}


////////////////////////////////////////////////////////////////
// ͽ
// PortAͤϰŪ¸,ݡȥ꡼ɻ˽
// ΥǡɤޤƤʤн
////////////////////////////////////////////////////////////////
BOOL cP6intr::SetIntrReserved( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][SetIntrReserved]\n" );
	
// ڳ߶ػ߻ΥϤԶ礬ȯ뤿Ȥꤢ̵
//	if( IntrReserved ) return FALSE;
//	else{
		IntrReserved = TRUE;
		IntrPortA    = data;
		return TRUE;
//	}
}


////////////////////////////////////////////////////////////////
// ͽPortAåͼ
// :ߤPortA
////////////////////////////////////////////////////////////////
BYTE cP6intr::GetIntrReserved( BYTE data )
{
	PRINTD( INTR_LOG, "[INTR][GetIntrReserved]\n" );
	
	if( IntrReserved ){
		IntrReserved = FALSE;
		return IntrPortA;
	}else
		return data;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL cP6intr::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "INTR", NULL, "TimerIntrEnable",		"%s",		TimerIntrEnable ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrKEY1",			"%s",		IntrKEY1 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrKEY2",			"%s",		IntrKEY2 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrKEY3",			"%s",		IntrKEY3 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrTIMER",			"%s",		IntrTIMER ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrCMT_R",			"%s",		IntrCMT_R ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrCMT_E",			"%s",		IntrCMT_E ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrJOY",				"%s",		IntrJOY ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "TimerAddr",			"0x%02X",	TimerAddr );
	Ini->PutEntry( "INTR", NULL, "IntrReserved",		"%s",		IntrReserved ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "IntrPortA",			"0x%02X",	IntrPortA );
	Ini->PutEntry( "INTR", NULL, "ResCmt",				"0x%02X",	ResCmt );
	
	return TRUE;
}

BOOL cP6intr62::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "INTR", NULL, "TimerIntrEnable2",	"%s",		TimerIntrEnable2 ? "Yes" : "No" );
	Ini->PutEntry( "INTR", NULL, "Int1Addr",			"0x%02X",	Int1Addr );
	Ini->PutEntry( "INTR", NULL, "Int2Addr",			"0x%02X",	Int2Addr );
	
	return cP6intr::DokoSave( Ini );
}



////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL cP6intr::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "INTR", "TimerIntrEnable",	&TimerIntrEnable,	TimerIntrEnable );
	Ini->GetTruth( "INTR", "IntrKEY1",			&IntrKEY1,			IntrKEY1 );
	Ini->GetTruth( "INTR", "IntrKEY2",			&IntrKEY2,			IntrKEY2 );
	Ini->GetTruth( "INTR", "IntrKEY3",			&IntrKEY3,			IntrKEY3 );
	Ini->GetTruth( "INTR", "IntrTIMER",			&IntrTIMER,			IntrTIMER );
	Ini->GetTruth( "INTR", "IntrCMT_R",			&IntrCMT_R,			IntrCMT_R );
	Ini->GetTruth( "INTR", "IntrCMT_E",			&IntrCMT_E,			IntrCMT_E );
	Ini->GetTruth( "INTR", "IntrJOY",			&IntrJOY,			IntrJOY );
	Ini->GetInt(   "INTR", "TimerAddr",			&st,				TimerAddr );	TimerAddr = st;
	Ini->GetTruth( "INTR", "IntrReserved",		&IntrReserved,		IntrReserved );
	Ini->GetInt(   "INTR", "IntrPortA",			&st,				IntrPortA );	IntrPortA = st;
	Ini->GetInt(   "INTR", "ResCmt",			&st,				ResCmt );		ResCmt = st;
	
	return TRUE;
}

BOOL cP6intr62::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "INTR", "TimerIntrEnable2",	&TimerIntrEnable2,	TimerIntrEnable2 );
	Ini->GetInt(   "INTR", "Int1Addr",			&st,				Int1Addr );		Int1Addr = st;
	Ini->GetInt(   "INTR", "Int2Addr",			&st,				Int2Addr );		Int2Addr = st;
	
	return cP6intr::DokoLoad( Ini );
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor cP6intr60::descriptor = {
	cP6intr60::indef, cP6intr60::outdef
};

const Device::OutFuncPtr cP6intr60::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP6intr60::OutB0H )
};

const Device::InFuncPtr cP6intr60::indef[] = {
};


const Device::Descriptor cP6intr62::descriptor = {
	cP6intr62::indef, cP6intr62::outdef
};

const Device::OutFuncPtr cP6intr62::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &cP6intr62::OutB0H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6intr62::OutF3H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6intr62::OutF4H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6intr62::OutF5H ),
	STATIC_CAST( Device::OutFuncPtr, &cP6intr62::OutF7H )
};

const Device::InFuncPtr cP6intr62::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &cP6intr62::InF7H )
};
