#ifndef OSD_H_INCLUDED
#define OSD_H_INCLUDED

// OSˑ̔ėp[`(UIp)
// ɍ킹ĕR[hύX邱
//  Windows : ShiftJIS
//  Unix    : EUC

#include "pc6001v.h"

////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cOsd {
private:
	enum FileMode
	{
		FileLoad,
		FileSave
	};
	static char *FileDiaog( void *, FileMode, char *, char *, char *, char *, char * );	// t@C̎Q
	
public:
	cOsd();											// RXgN^
	~cOsd();										// fXgN^
	
	// vZXǗ
	static BOOL IsWorking();						// dN`FbN
	static void Finish();							// I
	
	// t@C֌W
	static int GetModulePath( char * );				// W[pX擾
	static BOOL FileExist( char * );				// t@C̑݃`FbN
	static char *GetFileNamePart( char * );			// tpXt@C擾
	
	// t@CI_CAO
	enum FileDlg
	{
		TapeLoad,
		TapeSave,
		Disk,
		ExtRom,
		Printer,
		FontZ,
		FontH,
		DokoLoad,
		DokoSave,
		
		EndofFileDlg
	};
	static char *FileSelect( void *, FileDlg, char *, char * );	// et@CI
	
	// bZ[W\
	static int Message( char *, char *, int );		// bZ[W\
	static const char *ColorName[];
};


// bZ[W{bNX̃^Cv
#define	OSDM_OK				0x000
#define	OSDM_OKCANCEL		0x001
#define	OSDM_YESNO			0x002
#define	OSDM_YESNOCANCEL	0x003

// bZ[W{bNX̃ACR^Cv
#define	OSDM_ICONERROR		0x010
#define	OSDM_ICONQUESTION	0x020
#define	OSDM_ICONWARNING	0x030
#define	OSDM_ICONINFO		0x040

// bZ[W{bNX̖߂l
#define	OSDR_OK				0x00
#define	OSDR_CANCEL			0x01
#define	OSDR_YES			0x02
#define	OSDR_NO				0x03

// ėp}N
#define DELIMITER(fn)		{while( char *c = strchr( fn, '\\') ) *c = '/';}
#define UNDELIMITER(fn)		{while( char *c = strchr( fn, '/') ) *c = '\\';}
#define ADDDELIMITER(fn)	{if(!strlen(fn)) strncpy(fn,"/",PATH_MAX); else if((fn[strlen(fn)-1] != '/')&&(fn[strlen(fn)-1] != '\\')) strncat(fn,"/",PATH_MAX);}
#define DELDELIMITER(fn)	{if(strlen(fn)>1) while( (fn[strlen(fn)-1] == '/')||(fn[strlen(fn)-1] == '\\') ) fn[strlen(fn)-1] = '\0';}


// MessagepbZ[W ------
#define	MSGE_ERROR		"Error"
// memory.cpp
#define	MSGE_ROMLOAD	" ̓Ǎ݂Ɏs܂"
#define	MSGE_LDERROR	"ROM Load Error"
// osdwin.cpp
#define	MSG_RESTART		"ύX͍ċNɗLƂȂ܂B\nċN܂?"
#define	MSG_RESTARTC	"ċNmF"
#define	MSGE_INIREAD	"INIt@C̓Ǎ݂Ɏs܂"
#define	MSGE_INIWRITE	"INIt@C̕ۑɎs܂"
#define	MSG_RESETI		"gROM}ăZbg܂B"
#define	MSG_RESETE		"gROMroăZbg܂B"
#define	MSG_RESETC		"ZbgmF"

// INIt@CpbZ[W ------
// [CONFIG]
#define	MSINI_TITLE			"; === PC6001V ݒt@C ===\n\n"
#define	MSINI_Model			" @ 60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR"
#define	MSINI_Mode4Color	" MODE4J[[h 0:mN 1:/ 2:/ 3:sN/ 4:/sN"
#define	MSINI_SampleRate	" TvO[g (44100/22050/11025)Hz"
#define	MSINI_SoundBuffer	" TEhobt@(ms)"
#define	MSINI_FDD			" FDDڑ䐔 (0-2)"
#define	MSINI_ExtRam		" gRAMgp"
#define	MSINI_KeyRepeat		" L[s[g̊Ԋu(P:ms 0Ŗ)"
#define	MSINI_ScanLine		" XLC Yes: No:Ȃ"
#define	MSINI_ScanLineBr	" XLCPx (0-100)%"
#define	MSINI_TurboTAPE		" Turbo TAPE Yes:L No:"
#define	MSINI_FrameRate		" t[[g (10-60)"
#define	MSINI_MasterVolume	" }X^[ (0-100)"
#define	MSINI_PsgVolume		" PSG (0-100)"
#define	MSINI_VoiceVolume	"  (0-100)"
#define	MSINI_TapeVolume	" TAPEj^ (0-100)"
#define	MSINI_OverClock		" I[o[NbN (1-1000)%"
#define	MSINI_CheckCRC		" CRC`FbN TRUE:L FALSE:"
// [FILES]
#define	MSINI_ExtRom		" gROMt@C"
#define	MSINI_tape			" TAPE(LODE)t@C(NɎ}Eg)"
#define	MSINI_save			" TAPE(SAVE)t@C(SAVEɎ}Eg)"
#define	MSINI_disk			" DISKt@C(NɎ}Eg)"
#define	MSINI_printer		" v^o̓t@C"
#define	MSINI_fontz			" SptHgt@C"
#define	MSINI_fonth			" ptHgt@C"
// [PATH]
#define	MSINI_RomPath		" ROMC[Wi[pX"
#define	MSINI_TapePath		" TAPEC[Wi[pX"
#define	MSINI_DiskPath		" DISKC[Wi[pX"
#define	MSINI_ExtRomPath	" gROMC[Wi[pX"
#define	MSINI_ImgPath		" XibvVbgi[pX"
#define	MSINI_FontPath		" FONTi[pX"
// [COLOR]

// ǂłSAVEpbZ[W ------
#define	MSDOKO_TITLE		"; === PC6001V ǂłSAVEt@C ===\n\n"


#endif	// OSD_H_INCLUDED
