#ifndef SOUND_H_INCLUDED
#define SOUND_H_INCLUDED

#include "pc6001v.h"
#include "SCritical.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
// ȥ꡼κ
// PSGx3 + TAPE + VOICE = 5
#define	MAXSTREAM	5

// ХåեΨ
#define	MULTI	2

class cRing : public SCritical {
private:
	Sint16 *Buffer;					// ХåեؤΥݥ
	
	int Size;						// Хåե(ǡ)
	int Wpt;						// ߥݥ
	int Rpt;						// ɹߥݥ
	int Num;						// ̤ɥǡ
	
public:
	cRing();						// 󥹥ȥ饯
	~cRing();						// ǥȥ饯
	
	BOOL Init( int );				// 
	
	Sint16 Read();					// ɹ
	BOOL Write( Sint16 );			// 
	
	int ReadySize(){ return Num > Size/MULTI ? Size/MULTI : Num; };		// ̤ɥǡ
	int FreeSize(){ return Num > Size/MULTI ? 0 : Size/MULTI-Num; };	// ĤХåե
	
//	Sint16 * GetBuffer(){ return Buffer; };	// ХåեؤΥݥ󥿼
};


class cSound {
private:
	SDL_AudioSpec ASpec;			// ǥڥå
	cRing *RB[MAXSTREAM];			// ȥ꡼ݥ
	int Volume;						// ޥ
	
public:
	cSound();						// 󥹥ȥ饯
	~cSound();						// ǥȥ饯
	
	BOOL Init( void *, void (*)(void *, Uint8 *, int ), int, int );	// 
	
	cRing *AddStream();				// ȥ꡼ɲ
	
	void Play();					// 
	void Pause();					// 
	
	void SetVolume( int );			// ޥ
	
	void Update( Uint8 *, int );	// ɹؿ
};

#endif	// SOUND_H_INCLUDED
