#ifndef TAPE_H_INCLUDED
#define TAPE_H_INCLUDED

#include "pc6001v.h"
#include "global.h"
#include "ini.h"
#include "sound.h"

#include "p6t2.h"


// ǡμ
#define PG_P	(0x0000)
#define PG_S	(0x0100)
#define PG_D	(0x0200)


// ưϾ¤
// ưϥХåե
#define NumOfAKEY 128
typedef struct{
	char Buffer[NumOfAKEY];	// Хåե
	int Num;				// Ĥʸ
	int Wait;				// Ԥ
	BOOL Relay;				// 졼åOFFԤե饰
	int Seek;
} AKEY;


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cP6tape : public IDoko {
private:
	cP6T *p6t;
	
	char FilePath[MAX_PATH];	// եΥեѥ
	
	WORD CmtRead();				// CMT 1ʸɹ
	Sint16 GetSinCurve( int );	// sinȼ
	
	cRing *Buf;					// ȥ꡼ݥ
	int Volume;					// TAPE˥
	
	BOOL AutoStartExec;			// ȥȼ¹ԥե饰
	AKEY ak;					// ưϾ¤
	
public:
	cP6tape();					// 󥹥ȥ饯
	virtual ~cP6tape();			// ǥȥ饯
	
	BOOL Init( cRing * );		// 
	void Reset();				// ꥻå
	
	BOOL Mount( char * );		// TAPE ޥ
	void Unmount();				// TAPE ޥ
	
	void SetVolume( int );		// TAPE˥
	
	WORD Update();				// ȥ꡼๹
	
	BYTE GetAutoKey( BOOL );	// ȥ1ʸ
	
	BOOL IsAutoStart(){ return AutoStartExec; }	// ȥȼ¹ԥե饰
	DWORD GetSize();			// ٥᡼
	char *GetTapeName();		// TAPE̾
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class cP6csave {
private:
	FILE *fp;					// FILE ݥ
	WORD Baud;					// ܡ졼
	
	char FilePath[PATH_MAX];	// TAPE(SAVE)եեѥ
	
public:
	cP6csave();					// 󥹥ȥ饯
	~cP6csave();				// ǥȥ饯
	
	BOOL Init( char * );		// 
	
	BOOL Mount( char * );
	void Unmount();
	
	void CmtWrite( BYTE );		// CMT 1ʸ
	
	void SetBaud( WORD b ){ Baud = b; }	// ܡ졼
};


#endif	// TAPE_H_INCLUDED
